#ifndef __EVENT_QUEUE_H
#define __EVENT_QUEUE_H

/* Includes */

#include "hw_config.h"
#include "hw_types.h"

/* Exported constants */

typedef enum
{
    CRZ_EVENT_NONE = 0,

    /* Work Events */

    CRZ_EVENT_WORK_USER_KEY_1_PRESS          = 0x1,
    CRZ_EVENT_WORK_USER_KEY_1_RELEASE        = 0x2,
    CRZ_EVENT_WORK_USER_KEY_2_PRESS          = 0x3,
    CRZ_EVENT_WORK_USER_KEY_2_RELEASE        = 0x4,

    /* Error Events */

#if 0
    CRZ_EVENT_ERROR_...         = 0xE0,
    CRZ_EVENT_ERROR_...         = 0xE1,
    CRZ_EVENT_ERROR_...         = 0xE4,
#endif

    CRZ_EVENT_MAX  = 0xFFFFFFFF
}
EventQueue_EventID_E;

typedef struct
{
    EventQueue_EventID_E  event_id; 
    uint32_t              event_data;
}
EventQueue_Data_S;

/* Exported functions */

// EVENT Queue for Comm

void EventQueue_Initialize(void);
CRZ_bool EventQueue_Is_Empty(void);
void EventQueue_EnQueue(EventQueue_EventID_E id, uint32_t data);
EventQueue_Data_S EventQueue_DeQueue(void);

#endif /* __EVENT_QUEUE_H */

