/*
 * (C) COPYRIGHT 2016 CRZ
 *
 * File Name : LED_Test.c
 * Author    : POOH
 * Version   : V1.0
 * Date      : 01/07/2016
 */

/* includes */

#include "hw_config.h"

/* defines */

/* global variables */

/* functions */

void LED_Initialization(void)
{
    MANGO_DBG_DEFAULT;

    BSP_LED_Init(LED1);
    BSP_LED_Init(LED2);
    BSP_LED_Init(LED3);
}

static CRZ_bool g_print_menu_control_flag = CRZ_TRUE;

static void print_menu_command(void)
{
    if(CRZ_TRUE == g_print_menu_control_flag)
    {
        printf("\n---------------------\n");
        printf("Press menu key\n");
        printf("---------------------\n");
        printf("1> LED1 On\n");
        printf("2> LED2 On\n");
        printf("3> LED3 On\n");
        printf("4> LED1 Off\n");
        printf("5> LED2 Off\n");
        printf("6> LED3 Off\n");
        printf("7> LED1 Toggle\n");
        printf("8> LED2 Toggle\n");
        printf("9> LED3 Toggle\n");
        printf("---------------------\n");
        printf("x> exit\n");
        printf("---------------------\n");
    }

    g_print_menu_control_flag = CRZ_FALSE;
}

void LED_Test(void)
{
    char ch;

    MANGO_DBG_DEFAULT_BLUE;

    /* Infinite loop */
    while (1)
    {
        print_menu_command();

        if(CRZ_TRUE == UartQueue_Serial_Is_Empty())
        {
            continue;
        }

        ch = UartQueue_Serial_DeQueue();

        if(0 != ch)
        {
            g_print_menu_control_flag = CRZ_TRUE;

            MANGO_DBG_BLUE("%c is selected\n", ch);

            switch(ch)
            {
            case '1':
                BSP_LED_On(LED1);
                break;

            case '2':
                BSP_LED_On(LED2);
                break;

            case '3':
                BSP_LED_On(LED3);
                break;

            case '4':
                BSP_LED_Off(LED1);
                break;

            case '5':
                BSP_LED_Off(LED2);
                break;

            case '6':
                BSP_LED_Off(LED3);
                break;

            case '7':
                BSP_LED_Toggle(LED1);
                break;

            case '8':
                BSP_LED_Toggle(LED2);
                break;

            case '9':
                BSP_LED_Toggle(LED3);
                break;

            case 'x':
                return;
            }
        }
    }
}

