
/* Includes */

#include "hw_config.h"

/* Defines */

#define  EVENT_QUEUE_BUFFER_SIZE  200

/* Static Functions */

__STATIC_INLINE void event_queue_increase_point_value(uint32_t * data_p)
{
    (* data_p) ++;
    if(EVENT_QUEUE_BUFFER_SIZE == (* data_p))
    {
        (* data_p) = 0;
    }
}

/* Global Functions */

// event Queue for Comm

EventQueue_Data_S  event_queue_buffer[EVENT_QUEUE_BUFFER_SIZE];

uint32_t  event_queue_point_head = 0;
uint32_t  event_queue_point_tail = 0;

void EventQueue_Initialize(void)
{
    event_queue_point_head = event_queue_point_tail = 0;
}

CRZ_bool EventQueue_Is_Empty(void)
{
    if(event_queue_point_head == event_queue_point_tail)
    {
        return CRZ_TRUE;
    }
    return CRZ_FALSE;
}

void EventQueue_EnQueue(EventQueue_EventID_E id, uint32_t data)
{
    event_queue_buffer[event_queue_point_head].event_id   = id;
    event_queue_buffer[event_queue_point_head].event_data = data;
    event_queue_increase_point_value(&event_queue_point_head);
}

EventQueue_Data_S EventQueue_DeQueue(void)
{
    EventQueue_Data_S retVal = event_queue_buffer[event_queue_point_tail];
    event_queue_increase_point_value(&event_queue_point_tail);
    return retVal;
}

